"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ChromosomeBase {
    constructor(_length) {
        this._length = _length;
        // eslint-disable-next-line no-magic-numbers
        this.fitness = undefined;
        // eslint-disable-next-line no-magic-numbers
        if (_length < 2) {
            throw new Error('Too short.');
        }
        this.genes = new Array(_length);
    }
    get length() {
        return this._length;
    }
    getGene(index) {
        return this.genes[index];
    }
    setGene(index, gene) {
        this.genes[index] = gene;
    }
    generateGenes() {
        [...Array(this.length).keys()].forEach(index => this.setGene(index, this.generateGene(index)));
    }
    clone() {
        const clone = this.createNew();
        clone.copyFrom(this);
        return clone;
    }
    copyFrom(from) {
        if (from.length !== this.length) {
            throw new Error('Length is not same.');
        }
        // eslint-disable-next-line no-magic-numbers
        for (let index = this.length; --index >= 0;) {
            this.genes[index] = from.getGene(index);
        }
        this.fitness = from.fitness;
    }
    mutation(index) {
        this.genes[index] = this.generateGene(index);
    }
}
exports.ChromosomeBase = ChromosomeBase;
//# sourceMappingURL=ChromosomeBase.js.map